<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLContainersSubgraphBase&lt; CVertex &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classTIGLContainersSubgraphBase-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLContainersSubgraphBase&lt; CVertex &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__data__structures.html">Data Structures</a> &#124; <a class="el" href="group__containers.html">Graph Containers</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core data container for a subgraph in each device.  
 <a href="classTIGLContainersSubgraphBase.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglContainersSubgraphBase_8hpp_source.html">tiglContainersSubgraphBase.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for TIGLContainersSubgraphBase&lt; CVertex &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classTIGLContainersSubgraphBase.png" usemap="#TIGLContainersSubgraphBase&lt; CVertex &gt;_map" alt=""/>
  <map id="TIGLContainersSubgraphBase&lt; CVertex &gt;_map" name="TIGLContainersSubgraphBase&lt; CVertex &gt;_map">
<area href="classTIGLContainersSubgraph.html" title="Graph container for each device in the TIGL. " alt="TIGLContainersSubgraph&lt; CVertex, MessageType &gt;" shape="rect" coords="0,56,312,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa808fe135a0ae28b9b9538254b267d81"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aa808fe135a0ae28b9b9538254b267d81">TIGLContainersSubgraphBase</a> (bool isDireted=true, ID_TYPE assignedHashSize=0)</td></tr>
<tr class="memdesc:aa808fe135a0ae28b9b9538254b267d81"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor of <a class="el" href="classTIGLContainersSubgraphBase.html" title="Core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a>.  <a href="#aa808fe135a0ae28b9b9538254b267d81">More...</a><br /></td></tr>
<tr class="separator:aa808fe135a0ae28b9b9538254b267d81"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a51b29e57ffd8f5dca1917ae8d2e38319"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a51b29e57ffd8f5dca1917ae8d2e38319">TIGLContainersSubgraphBase</a> (VERTEX_LIST_TYPE &amp;init_adj_list, bool isDireted, ID_TYPE assignedHashSize=0)</td></tr>
<tr class="memdesc:a51b29e57ffd8f5dca1917ae8d2e38319"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded constructor of <a class="el" href="classTIGLContainersSubgraphBase.html" title="Core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a>.  <a href="#a51b29e57ffd8f5dca1917ae8d2e38319">More...</a><br /></td></tr>
<tr class="separator:a51b29e57ffd8f5dca1917ae8d2e38319"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d861bdd7ba46573c8dc83f3bf1e4670"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a7d861bdd7ba46573c8dc83f3bf1e4670">exist</a> (ID_TYPE id)</td></tr>
<tr class="memdesc:a7d861bdd7ba46573c8dc83f3bf1e4670"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks the existence of a vertex.  <a href="#a7d861bdd7ba46573c8dc83f3bf1e4670">More...</a><br /></td></tr>
<tr class="separator:a7d861bdd7ba46573c8dc83f3bf1e4670"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae212d67e8129f85b2e4761aae98de3c0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae212d67e8129f85b2e4761aae98de3c0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#ae212d67e8129f85b2e4761aae98de3c0">reset</a> ()</td></tr>
<tr class="memdesc:ae212d67e8129f85b2e4761aae98de3c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialization procedure. <br /></td></tr>
<tr class="separator:ae212d67e8129f85b2e4761aae98de3c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5e592a368623209324164edc1317c65"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#ae5e592a368623209324164edc1317c65">findPos</a> (ID_TYPE &amp;id, uint_fast32_t &amp;pos)</td></tr>
<tr class="memdesc:ae5e592a368623209324164edc1317c65"><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds the position of a given vertex (from its id)  <a href="#ae5e592a368623209324164edc1317c65">More...</a><br /></td></tr>
<tr class="separator:ae5e592a368623209324164edc1317c65"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaeab2fc8f6ebf89e4e055d92972e92da"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aaeab2fc8f6ebf89e4e055d92972e92da">addVertex</a> (<a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &amp;x)</td></tr>
<tr class="memdesc:aaeab2fc8f6ebf89e4e055d92972e92da"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a single vertex to the vertex list.  <a href="#aaeab2fc8f6ebf89e4e055d92972e92da">More...</a><br /></td></tr>
<tr class="separator:aaeab2fc8f6ebf89e4e055d92972e92da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19e7dea824e424684b5f4d7b75aa96df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a19e7dea824e424684b5f4d7b75aa96df">createVerticesList</a> (ID_TYPE &amp;numVertices)</td></tr>
<tr class="memdesc:a19e7dea824e424684b5f4d7b75aa96df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates vertex list with trivial vertices.  <a href="#a19e7dea824e424684b5f4d7b75aa96df">More...</a><br /></td></tr>
<tr class="separator:a19e7dea824e424684b5f4d7b75aa96df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abe60d27a79937a07b4324944f814c383"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#abe60d27a79937a07b4324944f814c383">addVertex</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:abe60d27a79937a07b4324944f814c383"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds an empty vertex (by id)  <a href="#abe60d27a79937a07b4324944f814c383">More...</a><br /></td></tr>
<tr class="separator:abe60d27a79937a07b4324944f814c383"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5833ead8d95633e6a1012b1e93e7b3aa"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a5833ead8d95633e6a1012b1e93e7b3aa">addVertex_consistent</a> (<a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &amp;x)</td></tr>
<tr class="memdesc:a5833ead8d95633e6a1012b1e93e7b3aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a single vertex after checking its existence.  <a href="#a5833ead8d95633e6a1012b1e93e7b3aa">More...</a><br /></td></tr>
<tr class="separator:a5833ead8d95633e6a1012b1e93e7b3aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a802c364b5f7d1d6b58ba1d85eec70003"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a802c364b5f7d1d6b58ba1d85eec70003">removeVertex</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:a802c364b5f7d1d6b58ba1d85eec70003"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a single vertex (by id) from the subgraph.  <a href="#a802c364b5f7d1d6b58ba1d85eec70003">More...</a><br /></td></tr>
<tr class="separator:a802c364b5f7d1d6b58ba1d85eec70003"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca2763f8932ad1ec01be6f4db7231413"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aca2763f8932ad1ec01be6f4db7231413">addOutEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:aca2763f8932ad1ec01be6f4db7231413"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a single unweighted edge to the output edge buffer of the source vertex.  <a href="#aca2763f8932ad1ec01be6f4db7231413">More...</a><br /></td></tr>
<tr class="separator:aca2763f8932ad1ec01be6f4db7231413"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acfe7c01ba6c2084bdaacff168b2ef7df"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#acfe7c01ba6c2084bdaacff168b2ef7df">addOutEdge</a> (ID_TYPE src, EDGE_TYPE edge)</td></tr>
<tr class="memdesc:acfe7c01ba6c2084bdaacff168b2ef7df"><td class="mdescLeft">&#160;</td><td class="mdescRight">(Overloaded function) Adds a single edge to the output edge buffer of the source vertex  <a href="#acfe7c01ba6c2084bdaacff168b2ef7df">More...</a><br /></td></tr>
<tr class="separator:acfe7c01ba6c2084bdaacff168b2ef7df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8d1a727fba68cd0778e11ba7a36a58e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aa8d1a727fba68cd0778e11ba7a36a58e">addInEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:aa8d1a727fba68cd0778e11ba7a36a58e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a single edge to the input edge buffer (if exists) of the target vertex.  <a href="#aa8d1a727fba68cd0778e11ba7a36a58e">More...</a><br /></td></tr>
<tr class="separator:aa8d1a727fba68cd0778e11ba7a36a58e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a54e62d2e01e756de1784880affe7d82a"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a54e62d2e01e756de1784880affe7d82a">addInEdge</a> (ID_TYPE target, EDGE_TYPE edge)</td></tr>
<tr class="memdesc:a54e62d2e01e756de1784880affe7d82a"><td class="mdescLeft">&#160;</td><td class="mdescRight">(Overloaded function) Adds a single edge to the input edge buffer of the target vertex  <a href="#a54e62d2e01e756de1784880affe7d82a">More...</a><br /></td></tr>
<tr class="separator:a54e62d2e01e756de1784880affe7d82a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b753a0835bd3c53821161f728ff2ec7"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a6b753a0835bd3c53821161f728ff2ec7">removeOutEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:a6b753a0835bd3c53821161f728ff2ec7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a single edge from the output edge buffer of the source vertex.  <a href="#a6b753a0835bd3c53821161f728ff2ec7">More...</a><br /></td></tr>
<tr class="separator:a6b753a0835bd3c53821161f728ff2ec7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa1c6226429fec67e1dd4e7f368d9ede0"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aa1c6226429fec67e1dd4e7f368d9ede0">removeInEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:aa1c6226429fec67e1dd4e7f368d9ede0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a single edge from the input edge buffer of the target vertex.  <a href="#aa1c6226429fec67e1dd4e7f368d9ede0">More...</a><br /></td></tr>
<tr class="separator:aa1c6226429fec67e1dd4e7f368d9ede0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbcd66caf3a82f115e13ad0f0a02fa1e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abbcd66caf3a82f115e13ad0f0a02fa1e"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#abbcd66caf3a82f115e13ad0f0a02fa1e">getNumVertices</a> ()</td></tr>
<tr class="memdesc:abbcd66caf3a82f115e13ad0f0a02fa1e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of vertices in the subgraph. <br /></td></tr>
<tr class="separator:abbcd66caf3a82f115e13ad0f0a02fa1e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adef090617cef9e01d43ed541e8944c80"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adef090617cef9e01d43ed541e8944c80"></a>
ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#adef090617cef9e01d43ed541e8944c80">getNumEdges</a> ()</td></tr>
<tr class="memdesc:adef090617cef9e01d43ed541e8944c80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of edges of local vertices. <br /></td></tr>
<tr class="separator:adef090617cef9e01d43ed541e8944c80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af433f6fa9252112db0e30a3f5977a683"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af433f6fa9252112db0e30a3f5977a683"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#af433f6fa9252112db0e30a3f5977a683">getVertex</a> (ID_TYPE &amp;id, VERTEX_ITERATOR *it)</td></tr>
<tr class="memdesc:af433f6fa9252112db0e30a3f5977a683"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to a vertex from its id. <br /></td></tr>
<tr class="separator:af433f6fa9252112db0e30a3f5977a683"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83c44bec5c8a95fd980391fb72c6be53"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a83c44bec5c8a95fd980391fb72c6be53"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a83c44bec5c8a95fd980391fb72c6be53">getVertexPos</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:a83c44bec5c8a95fd980391fb72c6be53"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the vertex in the vertex list from its id. <br /></td></tr>
<tr class="separator:a83c44bec5c8a95fd980391fb72c6be53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a610a858c82a1ac99a0db2b1b3fe4d404"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a610a858c82a1ac99a0db2b1b3fe4d404"></a>
VERTEX_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a610a858c82a1ac99a0db2b1b3fe4d404">getIndexedVertex</a> (ID_TYPE index)</td></tr>
<tr class="memdesc:a610a858c82a1ac99a0db2b1b3fe4d404"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to a vertex from its position. <br /></td></tr>
<tr class="separator:a610a858c82a1ac99a0db2b1b3fe4d404"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a652a7bfb74caade265d2b2faabb33b78"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a652a7bfb74caade265d2b2faabb33b78"></a>
VERTEX_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a652a7bfb74caade265d2b2faabb33b78">begin</a> ()</td></tr>
<tr class="memdesc:a652a7bfb74caade265d2b2faabb33b78"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the start iterator of the vertex list. <br /></td></tr>
<tr class="separator:a652a7bfb74caade265d2b2faabb33b78"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57fc3d9252217c378f22173788e99a2b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a57fc3d9252217c378f22173788e99a2b"></a>
VERTEX_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a57fc3d9252217c378f22173788e99a2b">end</a> ()</td></tr>
<tr class="memdesc:a57fc3d9252217c378f22173788e99a2b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the end iterator of the vertex list. <br /></td></tr>
<tr class="separator:a57fc3d9252217c378f22173788e99a2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a87245814100827177d2382ac80b37600"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a87245814100827177d2382ac80b37600"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a87245814100827177d2382ac80b37600">size</a> ()</td></tr>
<tr class="memdesc:a87245814100827177d2382ac80b37600"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the local number of vertices. <br /></td></tr>
<tr class="separator:a87245814100827177d2382ac80b37600"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b06aa85e18d204308127164f1a12ab1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6b06aa85e18d204308127164f1a12ab1"></a>
VERTEX_LIST_PTR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a6b06aa85e18d204308127164f1a12ab1">getVerticesPtr</a> ()</td></tr>
<tr class="memdesc:a6b06aa85e18d204308127164f1a12ab1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the vertex list. <br /></td></tr>
<tr class="separator:a6b06aa85e18d204308127164f1a12ab1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8649895f04c215f32442a3087c5c8cd3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a8649895f04c215f32442a3087c5c8cd3">isConnected</a> (ID_TYPE &amp;src, ID_TYPE &amp;target)</td></tr>
<tr class="memdesc:a8649895f04c215f32442a3087c5c8cd3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks whether two vertices are connected.  <a href="#a8649895f04c215f32442a3087c5c8cd3">More...</a><br /></td></tr>
<tr class="separator:a8649895f04c215f32442a3087c5c8cd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca8529bfd444ab738305122fd08664f3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aca8529bfd444ab738305122fd08664f3"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aca8529bfd444ab738305122fd08664f3">isDirected</a> ()</td></tr>
<tr class="memdesc:aca8529bfd444ab738305122fd08664f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if the graph is directed, false otherwise. <br /></td></tr>
<tr class="separator:aca8529bfd444ab738305122fd08664f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0d58cb49ff7fe169f56d9e933d63d13"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa0d58cb49ff7fe169f56d9e933d63d13"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aa0d58cb49ff7fe169f56d9e933d63d13">memoryUsage</a> ()</td></tr>
<tr class="memdesc:aa0d58cb49ff7fe169f56d9e933d63d13"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the approximate overall memory usage of the graph in MB. <br /></td></tr>
<tr class="separator:aa0d58cb49ff7fe169f56d9e933d63d13"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab9dafb37fe969bb2f7a2f13389140124"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab9dafb37fe969bb2f7a2f13389140124"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#ab9dafb37fe969bb2f7a2f13389140124">memory_usage</a> (uint_fast32_t &amp;sizeVerticesList, uint_fast32_t &amp;sizePos)</td></tr>
<tr class="memdesc:ab9dafb37fe969bb2f7a2f13389140124"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the detailed memory usage for the vertices and position buffers. <br /></td></tr>
<tr class="separator:ab9dafb37fe969bb2f7a2f13389140124"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac204b3c1f12a1b1741b4b8c11635298"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aac204b3c1f12a1b1741b4b8c11635298"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aac204b3c1f12a1b1741b4b8c11635298">MaxCollision</a> ()</td></tr>
<tr class="memdesc:aac204b3c1f12a1b1741b4b8c11635298"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the maximum collision in the hash table of the position. <br /></td></tr>
<tr class="separator:aac204b3c1f12a1b1741b4b8c11635298"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:ac45e55c7e818ee8db6456ee80b54f4cb"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac45e55c7e818ee8db6456ee80b54f4cb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#ac45e55c7e818ee8db6456ee80b54f4cb">DeallocPosTable</a> ()</td></tr>
<tr class="memdesc:ac45e55c7e818ee8db6456ee80b54f4cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deallocates the position list. <br /></td></tr>
<tr class="separator:ac45e55c7e818ee8db6456ee80b54f4cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaee9da2b9d250740c0407d449b2b3a4c"><td class="memItemLeft" align="right" valign="top">ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#aaee9da2b9d250740c0407d449b2b3a4c">hash</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:aaee9da2b9d250740c0407d449b2b3a4c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the hashed position of a given id.  <a href="#aaee9da2b9d250740c0407d449b2b3a4c">More...</a><br /></td></tr>
<tr class="separator:aaee9da2b9d250740c0407d449b2b3a4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a56b37400e7d47e6a278084defcd26778"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a56b37400e7d47e6a278084defcd26778"></a>
VERTEX_LIST_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a56b37400e7d47e6a278084defcd26778">vertexList</a></td></tr>
<tr class="memdesc:a56b37400e7d47e6a278084defcd26778"><td class="mdescLeft">&#160;</td><td class="mdescRight">vertexList: holds the physical storage of the subgraph <br /></td></tr>
<tr class="separator:a56b37400e7d47e6a278084defcd26778"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a03aff1a6c6f8bac92420673d84542e2a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a03aff1a6c6f8bac92420673d84542e2a"></a>
POS_LIST_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a03aff1a6c6f8bac92420673d84542e2a">vertexPos</a></td></tr>
<tr class="memdesc:a03aff1a6c6f8bac92420673d84542e2a"><td class="mdescLeft">&#160;</td><td class="mdescRight">vertexPos: holds the position of each vertex in the adjacancy list <br /></td></tr>
<tr class="separator:a03aff1a6c6f8bac92420673d84542e2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad395cc63b17e2c2bed0e47c044d5aeea"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad395cc63b17e2c2bed0e47c044d5aeea"></a>
vector&lt; uint_fast32_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#ad395cc63b17e2c2bed0e47c044d5aeea">posHoles</a></td></tr>
<tr class="memdesc:ad395cc63b17e2c2bed0e47c044d5aeea"><td class="mdescLeft">&#160;</td><td class="mdescRight">posHoles: holes in the vertex list that should be exploited first in adding vertex <br /></td></tr>
<tr class="separator:ad395cc63b17e2c2bed0e47c044d5aeea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36346fc960bbe56f1ce1ab9d0f9f9fca"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a36346fc960bbe56f1ce1ab9d0f9f9fca"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a36346fc960bbe56f1ce1ab9d0f9f9fca">flagDirected</a></td></tr>
<tr class="memdesc:a36346fc960bbe56f1ce1ab9d0f9f9fca"><td class="mdescLeft">&#160;</td><td class="mdescRight">flagDirected: true if directed graph, false if undirected graph <br /></td></tr>
<tr class="separator:a36346fc960bbe56f1ce1ab9d0f9f9fca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d2dc5c71e000a5a43abfb541b99ea97"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4d2dc5c71e000a5a43abfb541b99ea97"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersSubgraphBase.html#a4d2dc5c71e000a5a43abfb541b99ea97">posHashSize</a></td></tr>
<tr class="memdesc:a4d2dc5c71e000a5a43abfb541b99ea97"><td class="mdescLeft">&#160;</td><td class="mdescRight">the size of the position hash table <br /></td></tr>
<tr class="separator:a4d2dc5c71e000a5a43abfb541b99ea97"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename CVertex&gt;<br />
class TIGLContainersSubgraphBase&lt; CVertex &gt;</h3>

<p>Core data container for a subgraph in each device. </p>
<p>It contains the vertex list and the corresponding hashed position buffer. It also handles all graph mutations. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aa808fe135a0ae28b9b9538254b267d81"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::<a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDireted</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>assignedHashSize</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor of <a class="el" href="classTIGLContainersSubgraphBase.html" title="Core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">isDireted</td><td>true if directed graph, false if undirected graph </td></tr>
    <tr><td class="paramname">assignedHashSize</td><td>hash size of the position list (set to the default value if unassigned) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a51b29e57ffd8f5dca1917ae8d2e38319"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::<a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a> </td>
          <td>(</td>
          <td class="paramtype">VERTEX_LIST_TYPE &amp;&#160;</td>
          <td class="paramname"><em>init_adj_list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDireted</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>assignedHashSize</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded constructor of <a class="el" href="classTIGLContainersSubgraphBase.html" title="Core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">init_adj_list</td><td>the initial adjacent list of the subgraph (in the form of vector of vertices) </td></tr>
    <tr><td class="paramname">isDireted</td><td>true if directed graph, false if undirected graph </td></tr>
    <tr><td class="paramname">assignedHashSize</td><td>hash size of the position list (set to the default value if unassigned) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aa8d1a727fba68cd0778e11ba7a36a58e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::addInEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds a single edge to the input edge buffer (if exists) of the target vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a54e62d2e01e756de1784880affe7d82a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::addInEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">EDGE_TYPE&#160;</td>
          <td class="paramname"><em>edge</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>(Overloaded function) Adds a single edge to the input edge buffer of the target vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>destination vertx vertex </td></tr>
    <tr><td class="paramname">edge</td><td>edge object </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="aca2763f8932ad1ec01be6f4db7231413"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::addOutEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds a single unweighted edge to the output edge buffer of the source vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="acfe7c01ba6c2084bdaacff168b2ef7df"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::addOutEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">EDGE_TYPE&#160;</td>
          <td class="paramname"><em>edge</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>(Overloaded function) Adds a single edge to the output edge buffer of the source vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">edge</td><td>edge object </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="aaeab2fc8f6ebf89e4e055d92972e92da"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::addVertex </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds a single vertex to the vertex list. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>the new vertex (by reference) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abe60d27a79937a07b4324944f814c383"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::addVertex </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds an empty vertex (by id) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>vertex id </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5833ead8d95633e6a1012b1e93e7b3aa"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::addVertex_consistent </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds a single vertex after checking its existence. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>the new vertex (by reference) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vertex is added propoerly, false if it already exists </dd></dl>

</div>
</div>
<a class="anchor" id="a19e7dea824e424684b5f4d7b75aa96df"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::createVerticesList </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>numVertices</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Creates vertex list with trivial vertices. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">numVertices</td><td>total number of vertices in the list </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7d861bdd7ba46573c8dc83f3bf1e4670"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::exist </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Checks the existence of a vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>the vertex id </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vertex exists in the local subgraph, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="ae5e592a368623209324164edc1317c65"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::findPos </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t &amp;&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Finds the position of a given vertex (from its id) </p>
<p>For core graph algorithms the performance of this function is critical </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td><a class="el" href="classTIGLApiVertex.html" title="Core vertex class for the TIGL Engine (with only output edge buffer). ">TIGLApiVertex</a> id </td></tr>
    <tr><td class="paramname">pos</td><td>a reference in which the position is written </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vertex exist, false if the vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="aaee9da2b9d250740c0407d449b2b3a4c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::ID_TYPE <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::hash </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets the hashed position of a given id. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>the id of the requested vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the hashed position of the vertex </dd></dl>

</div>
</div>
<a class="anchor" id="a8649895f04c215f32442a3087c5c8cd3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::isConnected </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks whether two vertices are connected. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if connected, false if not connected </dd></dl>

</div>
</div>
<a class="anchor" id="aa1c6226429fec67e1dd4e7f368d9ede0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::removeInEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Removes a single edge from the input edge buffer of the target vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertx vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the edge does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a6b753a0835bd3c53821161f728ff2ec7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::removeOutEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Removes a single edge from the output edge buffer of the source vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertx vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the edge or the vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a802c364b5f7d1d6b58ba1d85eec70003"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt;::removeVertex </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Removes a single vertex (by id) from the subgraph. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>vertex id </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the vertex does not exist </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglContainersSubgraphBase_8hpp_source.html">tiglContainersSubgraphBase.hpp</a></li>
<li><a class="el" href="tiglContainersSubgraphBaseImplementation_8hpp_source.html">tiglContainersSubgraphBaseImplementation.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:59 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
